﻿-- Thanks to Tukz for the RegisterStateDriver Fix!
local cfg = nioConfig.Actionbars

if not cfg.enable then return end

local class = select(2, UnitClass("player"))

--check for miirgui
local miirgui, style = true
if not IsAddOnLoaded("miirGui") then
	style = nioConfig.actionbuttons
	miirgui = false
end


local function createanchor(frame, frametext, text, buttons, rows, anchor, x, y, bsize)
    frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8"})
    frame:SetBackdropColor(0,0,0,0)
    frame:SetWidth((((((bsize*cfg.globalscale)+cfg.barspacing+4)*buttons)/rows)-(cfg.barspacing+4))+20)
    frame:SetHeight(((((bsize*cfg.globalscale)+cfg.barspacing+4)*rows)-(cfg.barspacing+6))+20)
    frame:SetFrameStrata("BACKGROUND")
    frame:SetPoint(anchor, x, y)
    frame:SetClampedToScreen(true)
    frame:SetMovable(true)
    frame:SetUserPlaced(true)
    frametext:SetPoint("BOTTOMLEFT", frame, "TOPLEFT")
    frametext:SetFont(nioConfig.font, 12, "OUTLINE")
    frametext:SetText(text)
    frametext:Hide()
end

local function arrangebar(but, index, rows, anchor, alpha, mouseover, frame, maxb, bsize)
    local button = _G[but..index]
    button:ClearAllPoints()
    button:SetAlpha(alpha)
    if _G[but..index.."HotKey"] then
		if cfg.hide_hotkey then _G[but..index.."HotKey"]:SetAlpha(0)
		else
			_G[but..index.."HotKey"]:SetJustifyH("Right")
			_G[but..index.."HotKey"]:SetPoint("TOPRIGHT", button, "TOPRIGHT", 2,0)
		end
    end
	if cfg.hide_macro_name and _G[but..index.."Name"] then _G[but..index.."Name"]:SetAlpha(0) end

    if (button:GetWidth()) >= (bsize*cfg.globalscale) then
        button:SetHeight(bsize*cfg.globalscale)
        button:SetWidth(bsize*cfg.globalscale)
    end
	
	--Skin (from rActionbuttonstyler)
	if not miirgui then
		local name = button:GetName()
		local bo  = _G[name.."Border"] --Border
		local ic  = _G[name.."Icon"]
		local fbg  = _G[name.."FloatingBG"]
	
		if fbg then fbg:Hide() end  --floating background
		button:SetNormalTexture(style.NormalTexture)
		bo:SetTexture(style.Border)
		ic:SetTexCoord(0.1,0.9,0.1,0.9)
		ic:SetPoint("TOPLEFT", button, "TOPLEFT", -1, 1)
		ic:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", 1, 0)		
	else
		local name = button:GetName()
		local ic  = _G[name.."Icon"]
		local hl = button:GetHighlightTexture()

		button:SetHighlightTexture('Interface\\Buttons\\WHITE8x8')
		hl:SetVertexColor(1,1,1,0.3)
		
		ic:SetPoint("TOPLEFT", button, "TOPLEFT", -1, 1)
		ic:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", 1, 0)
	end
		
    if mouseover == true then
        local function showall(alphano)
            for j = 1, maxb do
                _G[but..j]:SetAlpha(alphano)
            end
        end
        frame:EnableMouse(true)
        frame:SetScript("OnEnter", function(self) showall(alpha) end)
        frame:SetScript("OnLeave", function(self) showall(0) end)
        button:SetAlpha(0)
        button:HookScript("OnEnter", function(self) showall(alpha) end)
        button:HookScript("OnLeave", function(self) showall(0) end)
    end
    if index == 1 then
        button:SetPoint("TOPLEFT",anchor,"TOPLEFT",10,-10)
    elseif but == "PetActionButton" and rows == 2 then
        _G[but..6]:SetPoint("TOPLEFT",anchor,"TOPLEFT",10,-(bsize+cfg.barspacing+15))
        if index ~= 6 then
            button:SetPoint("LEFT", _G[but..(index-1)], "RIGHT", cfg.barspacing+4, 0)
        end
    elseif rows == 2 then
        _G[but..7]:SetPoint("TOPLEFT",anchor,"TOPLEFT",10,-(bsize+cfg.barspacing+15))
        if index ~= 7 then
            button:SetPoint("LEFT", _G[but..(index-1)], "RIGHT", cfg.barspacing+4, 0)
        end
    elseif rows==3 then
        _G[but..5]:SetPoint("TOPLEFT",anchor,"TOPLEFT",10,-(bsize+cfg.barspacing+15))
        _G[but..9]:SetPoint("TOPLEFT",anchor,"TOPLEFT",10,-((bsize*2)+cfg.barspacing+6))
        if index ~= 5 or 9 then
            button:SetPoint("LEFT", _G[but..(index-1)], "RIGHT", cfg.barspacing+4, 0)
        end
    elseif rows==4 then
        _G[but..4]:SetPoint("TOPLEFT",anchor,"TOPLEFT",10,-(bsize+cfg.barspacing+6))
        _G[but..7]:SetPoint("TOPLEFT",anchor,"TOPLEFT",10,-((bsize*2)+cfg.barspacing+6))
        _G[but..10]:SetPoint("TOPLEFT",anchor,"TOPLEFT",10,-((bsize*3)+cfg.barspacing+6))
        if index ~= 4 or 7 or 10 then
            button:SetPoint("LEFT", _G[but..(index-1)], "RIGHT", cfg.barspacing+4, 0)
        end
    elseif rows==6 then
        _G[but..3]:SetPoint("TOPLEFT",anchor,"TOPLEFT",10,-(bsize+cfg.barspacing+15))
        _G[but..5]:SetPoint("TOPLEFT",anchor,"TOPLEFT",10,-((bsize*2)+cfg.barspacing+6*4))
        _G[but..7]:SetPoint("TOPLEFT",anchor,"TOPLEFT",10,-((bsize*3)+cfg.barspacing+6*5))
        _G[but..9]:SetPoint("TOPLEFT",anchor,"TOPLEFT",10,-((bsize*4)+cfg.barspacing+6*6))
        _G[but..11]:SetPoint("TOPLEFT",anchor,"TOPLEFT",10,-((bsize*5)+cfg.barspacing+6*7))
        if index ~= 3 or 5 or 7 or 9 or 11 then
            button:SetPoint("LEFT", _G[but..(index-1)], "RIGHT", cfg.barspacing+4, 0)
        end
    elseif rows==12 then
        button:SetPoint("TOPLEFT",anchor,"TOPLEFT",10,-(((bsize+5)*(index-1))+cfg.barspacing+8))
    else
        button:SetPoint("LEFT", _G[but..(index-1)], "RIGHT", cfg.barspacing+4, 0)
    end
end

local MainBarAnchor = CreateFrame("Frame", "Main Action Bar", UIParent, 'SecureHandlerStateTemplate')
local MainBarAnchorText = MainBarAnchor:CreateFontString("Main Action Bar")

local Bar2 = CreateFrame("Frame", "Bar 2", UIParent)
local Bar2Text = Bar2:CreateFontString("Bar 2")

local Bar3 = CreateFrame("Frame", "Bar 3", UIParent)
local Bar3Text = Bar3:CreateFontString("Bar 3")

local RightBar1 = CreateFrame("Frame", "Right Bar 1", UIParent)
local RightBar1Text = RightBar1:CreateFontString("Right Bar 1")

local RightBar2 = CreateFrame("Frame", "Right Bar 2", UIParent)
local RightBar2Text = RightBar2:CreateFontString("Right Bar 2")

local ShapeShiftBar = CreateFrame("Frame", "Shape Bar", UIParent, 'SecureHandlerStateTemplate')
local ShapeShiftBarText = ShapeShiftBar:CreateFontString("Shape Bar")

local PetBar = CreateFrame("Frame", "Pet Bar", UIParent)
local PetBarText = PetBar:CreateFontString("Pet Bar")

MainBarAnchor.vehicleExit = CreateFrame("Button", _, module, "SecureHandlerClickTemplate")

MainBarAnchor.vehicleExit:SetWidth(cfg.mbbsize-10)
MainBarAnchor.vehicleExit:SetHeight(cfg.mbbsize-10)
MainBarAnchor.vehicleExit:SetScale(0.8)
MainBarAnchor.vehicleExit:SetPoint('LEFT', ActionButton6, 'RIGHT', cfg.barspacing+4, 0)
MainBarAnchor.vehicleExit:SetNormalTexture("Interface\\Vehicles\\UI-Vehicles-Button-Exit-Up")
MainBarAnchor.vehicleExit:GetNormalTexture():SetTexCoord(.25, .75, .25, .75)
MainBarAnchor.vehicleExit:RegisterForClicks("AnyUp")
MainBarAnchor.vehicleExit:SetScript("OnClick", VehicleExit)
MainBarAnchor:SetFrameRef('vehicleExit', MainBarAnchor.vehicleExit)
MainBarAnchor.vehicleExit:SetMovable(true)
MainBarAnchor.vehicleExit:SetUserPlaced(true)
MainBarAnchor.vehicleExit:EnableMouse(true)
MainBarAnchor.vehicleExit:RegisterForDrag("LeftButton","RightButton")
MainBarAnchor.vehicleExit:SetScript("OnDragStart", function(self) if IsAltKeyDown() then bar:StartMoving() end end)
MainBarAnchor.vehicleExit:SetScript("OnDragStop", function(self) bar:StopMovingOrSizing() end)
MainBarAnchor.vehicleExit:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8", insets = {top = -2, left = -2, bottom = -2, right = -2}})
MainBarAnchor.vehicleExit:SetBackdropColor(0, 0, 0, 1)

local Page = {
	["DRUID"] = "[bonusbar:1,nostealth] 7; [bonusbar:1,stealth] 8; [bonusbar:2] 8; [bonusbar:3] 9; [bonusbar:4] 10;",
	["WARRIOR"] = "[bonusbar:1] 7; [bonusbar:2] 8; [bonusbar:3] 9;",
	["PRIEST"] = "[bonusbar:1] 7;",
	["ROGUE"] = "[bonusbar:1] 7; [form:3] 7;",
	["DEFAULT"] = "[bonusbar:5] 11; [bar:2] 2; [bar:3] 3; [bar:4] 4; [bar:5] 5; [bar:6] 6;",
}

function MainBarAnchor.getBar()
	local condition = Page['DEFAULT']
	local page = Page[class]
	if page then
		condition = condition.." "..page
	end
	condition = condition.." 1"
	return condition
end

--local Forms = GetNumShapeshiftForms()
local Forms = NUM_STANCE_SLOTS
--createanchor(MainBarAnchor, MainBarAnchorText,  "Main Bar", 12,      mbrows, "BOTTOM", -13, 25, mbbsize)
createanchor(MainBarAnchor, MainBarAnchorText,  "Main Bar", 12,      cfg.mbrows, cfg.mbpos[1], cfg.mbpos[2], cfg.mbpos[3], cfg.mbbsize)
createanchor(Bar2,          Bar2Text,           "Bar 2",    12,      cfg.b2rows, cfg.b2pos[1], cfg.b2pos[2], cfg.b2pos[3], cfg.b2bsize)
createanchor(Bar3,          Bar3Text,           "Bar 3",    12,      cfg.b3rows, cfg.b3pos[1], cfg.b3pos[2], cfg.b3pos[3], cfg.b3bsize)
createanchor(RightBar1,     RightBar1Text,      "Bar 4",    12,      cfg.b4rows, cfg.b4pos[1], cfg.b4pos[2], cfg.b4pos[3], cfg.b4bsize)
createanchor(RightBar2,     RightBar2Text,      "Bar 5",    12,      cfg.b5rows, cfg.b5pos[1], cfg.b5pos[2], cfg.b5pos[3], cfg.b5bsize)
createanchor(ShapeShiftBar, ShapeShiftBarText,  "Shape Bar", Forms,  cfg.ssrows, cfg.sspos[1], cfg.sspos[2], cfg.sspos[3], cfg.ssbsize)
createanchor(PetBar,        PetBarText,         "Pet Bar",  10,      cfg.petrows, cfg.petpos[1], cfg.petpos[2], cfg.petpos[3], cfg.petbsize)

MultiBarBottomLeft:SetParent(Bar2)
MultiBarBottomRight:SetParent(Bar3)
MultiBarLeft:SetParent(RightBar2)
MultiBarRight:SetParent(RightBar1)
PetActionBarFrame:SetParent(PetBar)
StanceBarFrame :SetParent(ShapeShiftBar)

for i = 1,12 do
    arrangebar("ActionButton",              i, cfg.mbrows, "Main Action Bar",  cfg.mbalpha, cfg.mbmo, MainBarAnchor, 12, cfg.mbbsize)
    arrangebar("MultiBarBottomLeftButton",  i, cfg.b2rows, "Bar 2",            cfg.b2alpha, cfg.b2mo, Bar2, 12, cfg.b2bsize)
    arrangebar("MultiBarBottomRightButton", i, cfg.b3rows, "Bar 3",            cfg.b3alpha, cfg.b3mo, Bar3, 12, cfg.b3bsize)
    arrangebar("MultiBarRightButton",       i, cfg.b4rows, "Right Bar 1",      cfg.b4alpha, cfg.b4mo, RightBar1, 12, cfg.b4bsize)
    arrangebar("MultiBarLeftButton",        i, cfg.b5rows, "Right Bar 2",      cfg.b5alpha, cfg.b5mo, RightBar2, 12, cfg.b5bsize)
    _G["ActionButton"..i]:SetParent(MainBarAnchor)
    MainBarAnchor:SetFrameRef('ActionButton'..i, _G['ActionButton'..i])
end
--local function ssbardo()
    for i = 1, NUM_STANCE_SLOTS  do 
        arrangebar("StanceButton", i, cfg.ssrows, "Shape Bar", cfg.ssalpha, cfg.ssmo, ShapeShiftBar, 7, cfg.ssbsize) 
    end
--end
--hooksecurefunc("StanceBar_Update", ssbardo); 

for i = 1, 10 do 
    arrangebar("PetActionButton", i, cfg.petrows, "Pet Bar", cfg.petalpha, cfg.petmo, PetBar, 10, cfg.petbsize) 
end

-- ExtraActionButton implementation
if cfg.show_extraactionbutton then
	nioextrabtn = CreateFrame("Frame", "Extra Action Button", UIParent, 'SecureHandlerStateTemplate')
	nioextrabtnText = nioextrabtn:CreateFontString("Extra Action Button")
	createanchor(nioextrabtn, nioextrabtnText,  "Extra Action Button", 1,      1, cfg.expos[1], cfg.expos[2], cfg.expos[3], 80)
	ExtraActionBarFrame:SetParent(nioextrabtn)
	ExtraActionBarFrame:ClearAllPoints()
	ExtraActionBarFrame:SetPoint("CENTER", nioextrabtn, "CENTER", 0, 0)
	ExtraActionBarFrame.ignoreFramePositionManager = true
end

local function MoveFunc(frame, text)
    if movebars==1 then
        frame:EnableMouse(true)
        frame:SetBackdropColor(0,0,0,.7)
        frame:RegisterForDrag("LeftButton","RightButton")
        frame:SetScript("OnDragStart", function(self) self:StartMoving() end)
        frame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
        text:Show()
    elseif movebars==0 then
        frame:SetBackdropColor(0,0,0,0)
        frame:SetScript("OnDragStart", function(self) self:StopMovingOrSizing() end)
        frame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
        text:Hide()
    end
end

SlashCmdList["MOVEFRAMES"] = function()
    if movebars~=1 then
        movebars = 1
    else
        movebars = 0
    end
    MoveFunc(MainBarAnchor, MainBarAnchorText)
    MoveFunc(Bar2, Bar2Text)
    MoveFunc(Bar3, Bar3Text)
    MoveFunc(RightBar1, RightBar1Text)
    MoveFunc(RightBar2, RightBar2Text)
    MoveFunc(ShapeShiftBar, ShapeShiftBarText)
    MoveFunc(PetBar, PetBarText)
	if nioextrabtn ~=nil then MoveFunc(nioextrabtn, nioextrabtnText) end
end

SlashCmdList["RESETBARS"] = function()
    local function ResetFunc(frame)
        frame:SetUserPlaced(false)
    end
    ResetFunc(MainBarAnchor)
    ResetFunc(Bar2)
    ResetFunc(Bar3)
    ResetFunc(RightBar1)
    ResetFunc(RightBar2)
    ResetFunc(ShapeShiftBar)
    ResetFunc(PetBar)
	if nioextrabtn ~=nil then ResetFunc(nioextrabtn) end
end

SLASH_MOVEFRAMES1 = "/movebars"
SLASH_RESETBARS1 = "/resetbars"

MainBarAnchor:Execute([[
	vehicleExit = self:GetFrameRef('vehicleExit')
	buttons = table.new()
	for i = 1, 12 do
		table.insert(buttons, self:GetFrameRef('ActionButton'..i))
	end
]])
MainBarAnchor:SetAttribute("_onstate-page", [[ 
	for i, button in ipairs(buttons) do
		button:SetAttribute("actionpage", tonumber(newstate))
	end
]])

MainBarAnchor:SetAttribute("_onstate-vehicle", [[
	if newstate == 1 then
		vehicleExit:Show()
		self:SetWidth(230)
		for i = 7, 12 do buttons[i]:Hide() end
	else
		vehicleExit:Hide()
		self:SetWidth(400)
		for i = 7, 12 do buttons[i]:Show() end
	end
]])
	
RegisterStateDriver(MainBarAnchor, "page", MainBarAnchor.getBar())
RegisterStateDriver(MainBarAnchor, "vehicle", "[bonusbar:5] 1; 0")

MainMenuBar:SetScale(0.001)
MainMenuBar:SetAlpha(0)
-- VehicleMenuBar:SetScale(0.001)
-- VehicleMenuBar:SetAlpha(0)