if not nioConfig.Misc.DamageMeter then return end

local n = select(2, ...)
local cfg = nioConfig.DamageMeter

-- window settings
n.windowsettings = {
	pos = cfg.pos,
	width = cfg.width,
	height = cfg.height,
	maxlines = cfg.maxlines,
	backgroundalpha = 0,
	scrollbar = true,

	titleheight = 16,
	titlealpha = 0.8,
	titlefont = [[Fonts\FRIZQT__.TTF]],
	titlefontsize = 12,
	titlefontcolor = {1, 1, 1},
	buttonhighlightcolor = {1, 1, 1},

	lineheight = 14,
	linegap = 1,
	linealpha = 1,
	linetexture = [[Interface\Addons\nioUI\Media\Minimalist.tga]],
	linefont = [[Fonts\FRIZQT__.TTF]],
	linefontsize = 11,
	linefontcolor = {1, 1, 1},
}

-- core settings
n.coresettings = {
	refreshinterval = 1,
	minfightlength = 15,
	combatseconds = 3,
	shortnumbers = true,
}

-- available types and their order
n.types = {
	{
		name = "Damage",
		id = "dd",
		--c = {.25, .66, .35},
		c = {0.1803921568627451, 0.1843137254901961, 0.1882352941176471},
	},
	{
		name = "Damage Targets",
		id = "dd",
		view = "Targets",
		onlyfights = true,
		c = {0.1803921568627451, 0.1843137254901961, 0.1882352941176471},
	},
	{
		name = "Damage Taken: Targets",
		id = "dt",
		view = "Targets",
		onlyfights = true,
		c = {0.1803921568627451, 0.1843137254901961, 0.1882352941176471},
	},
	{
		name = "Damage Taken: Abilities",
		id = "dt",
		view = "Spells",
		c = {0.1803921568627451, 0.1843137254901961, 0.1882352941176471},
	},
	{
		name = "Friendly Fire",
		id = "ff",
		c = {0.1803921568627451, 0.1843137254901961, 0.1882352941176471},
	},
	{
		name = "Healing + Absorbs",
		id = "hd",
		id2 = "ga",
		c = {0.1803921568627451, 0.1843137254901961, 0.1882352941176471},
	},
--	{
--		name = "Healing Taken: Abilities",
--		id = "ht",
--		view = "Spells",
--		c = {.25, .5, .85},
--	},
--	{
--		name = "Healing",
--		id = "hd",
--		c = {.25, .5, .85},
--	},
--	{
--		name = "Guessed Absorbs",
--		id = "ga",
--		c = {.25, .5, .85},
--	},
	{
		name = "Overhealing",
		id = "oh",
		c = {0.1803921568627451, 0.1843137254901961, 0.1882352941176471},
	},
	{
		name = "Dispels",
		id = "dp",
		c = {0.1803921568627451, 0.1843137254901961, 0.1882352941176471},
	},
	{
		name = "Interrupts",
		id = "ir",
		c = {0.1803921568627451, 0.1843137254901961, 0.1882352941176471},
	},
	{
		name = "Power Gains",
		id = "pg",
		c = {0.1803921568627451, 0.1843137254901961, 0.1882352941176471},
	},
	{
		name = "Death Log",
		id = "deathlog",
		view = "Deathlog",
		onlyfights = true,
		c = {0.1803921568627451, 0.1843137254901961, 0.1882352941176471},
	},
}
