if not nioConfig.LDB.Money then return end

wGMDB = {}
local wG = "|cffe1a500w|cff69ccf0Gold|cffffffff"
local ldb = LibStub("LibDataBroker-1.1")
local wGold = CreateFrame("Frame", "Broker_wGold")
local realmName = GetRealmName()
local myName = UnitName("player")
local myMoneyTotal = 0
local startingGold = 0
local merchantGold = 0
local function moneyFormat(copper, earned)
	local moneyGold = floor(abs(copper / 10000))
	local moneySilver = floor(abs(mod(copper / 100, 100)))
	local moneyCopper = floor(abs(mod(copper, 100)))
	if (earned==1) then -- Gold (earned) tooltip
		if (copper<0) then
			return ("|cffff0000 - "..moneyGold.."|cffffcc00g |cffff0000"..moneySilver.."|cffc0c0c0s |cffff0000"..moneyCopper.."|cff996600c")
		elseif (copper>0) then
			return ("|cff00ff00 "..moneyGold.."|cffffcc00g |cff00ff00"..moneySilver.."|cffc0c0c0s |cff00ff00"..moneyCopper.."|cff996600c")
		elseif (copper==0) then
			return (moneyGold.."|cffffcc00g |cffffffff"..moneySilver.."|cffc0c0c0s |cffffffff"..moneyCopper.."|cff996600c")
		end
	else
		--return ("|cffffffff"..moneyGold.."|cffffcc00g |cffffffff"..moneySilver.."|cffc0c0c0s |cffffffff"..moneyCopper.."|cff996600c")
		return ("|cffffffff"..moneyGold.."g")
	end
end
local function altRemove(alt)
	local name = alt.value
	for k,v in pairs(wGMDB[realmName]) do
		if (k==name) then
			print("|cffffff00"..name.." has been removed from the "..wG.."|cffffff00 database")
			wGMDB[realmName][name] = nil
		end
	end
end
local menuFrame = CreateFrame("Frame", "menuFrame", UIParent, "UIDropDownMenuTemplate", "MENU")
alts = {
	--[[{text = "Alt1", value = "1000g"},
	{text = "Alt2", value = "100g"},
	{text = "Alt3", value = "10g"},
	{text = "Alt4", value = "1g"}]]
}
local options = {
	{text = "Remove an alt", value = alts, notCheck = true, hasArrow = true},
	{text = nil, value = nil, disabled = true, notCheck = true},
	{text = "Close", value = nil, notCheck = true, keepShowOnClick = false, notCheck = true}
}
local function initialize(self, level)
	if (level==1) then
		local title = UIDropDownMenu_CreateInfo()
		title = UIDropDownMenu_CreateInfo()
		title.text = wG
		title.isTitle = true
		title.notCheckable = true
		UIDropDownMenu_AddButton(title, level)
		local info = UIDropDownMenu_CreateInfo()
		for k,v in pairs(options) do
			info = UIDropDownMenu_CreateInfo()
			if (v.disabled~=nil) then info.disabled = v.disabled end
			if (v.notCheck~=nil) then info.notCheckable = v.notCheck end
			if (v.hasArrow~=nil) then info.hasArrow = v.hasArrow info.menuList = v.subMenu end
			if (v.isNotRadio~=nil) then info.isNotRadio = v.isNotRadio end
			if (v.func~=nil) then info.func = v.func end
			info.text = v.text
			info.value = v.value
			info.keepShownOnClick = v.keepShownOnClick
			UIDropDownMenu_AddButton(info, level)
	   end
	elseif (level==2) then
		local info = UIDropDownMenu_CreateInfo()
		for k,v in pairs(alts) do
			info = UIDropDownMenu_CreateInfo()
			info.text = v.text
			info.value = v.value
			info.func, info.arg1 = altRemove, v.value
			info.isNotRadio = true
			info.notCheckable = true
			UIDropDownMenu_AddButton(info, level)
		end
	end
end
UIDropDownMenu_Initialize(menuFrame, initialize, "MENU")
UIDropDownMenu_SetWidth(menuFrame, 100);
UIDropDownMenu_SetButtonWidth(menuFrame, 124)
UIDropDownMenu_JustifyText(menuFrame, "LEFT")
local Broker_wGold = ldb:NewDataObject("Broker_wGold", {
	type = "data source",
	text = "0g",
	icon = "interface\\minimap\\tracking\\auctioneer",
	label = wG,
	OnClick = function(self, button)
		if button == "RightButton" then
			ToggleDropDownMenu(1, nil, menuFrame, self, 0, 15)
		end
	end,
	OnTooltipShow = function(tooltip)
		local moneyTotal = 0
		--[[local moneyToday = 0
		local moneyWeek = 0
		if (wGMDB[realmName]["today_info"]["gold"]~=nil) then moneyToday = moneyFormat((wGMDB[realmName]["today_info"]["gold"] + (GetMoney() - startingGold)),1) else moneyToday = 0 end
		if (wGMDB[realmName]["week_info"]["gold"]~=nil) then moneyWeek = moneyFormat((wGMDB[realmName]["week_info"]["gold"] + (GetMoney() - startingGold)),1) else moneyWeek = 0 end]]
		tooltip:AddLine(wG..":")
		tooltip:AddLine(" ")
		tooltip:AddDoubleLine("Gold earned (this session):", moneyFormat((GetMoney() - startingGold), 1),1,1,1,1,1,1)
		tooltip:AddDoubleLine("Gold earned (today):", moneyFormat((wGMDB[realmName]["today_info"]["gold"] + (GetMoney() - startingGold)),1),1,1,1,1,1,1)
		tooltip:AddDoubleLine("Gold earned (this week):", moneyFormat((wGMDB[realmName]["week_info"]["gold"] + (GetMoney() - startingGold)),1),1,1,1,1,1,1)
		tooltip:AddLine("________________________")
		tooltip:AddLine(" ")
		for k,v in pairs(wGMDB[realmName]) do
			if (k~=nil) and(k~="today_info") and (k~="week_info") then
				tooltip:AddDoubleLine(k..":", (moneyFormat(v)),1,1,1,1,1,1)
				moneyTotal = moneyTotal + v
			end
		end
		tooltip:AddLine("________________________")
		tooltip:AddLine(" ")
		tooltip:AddDoubleLine("Total:", moneyFormat(moneyTotal),1,1,1,1,1,1)
		tooltip:AddLine(" ")
		tooltip:AddLine("|cff69ccf0Right-Click|cffffd200 for options")
	end,
})

local function moneyUpdate()
	myMoneyTotal = GetMoney()
	local dateInfo = date("*t")
	Broker_wGold.text = (moneyFormat(myMoneyTotal))
	if (wGMDB[realmName]==nil) then wGMDB[realmName] = {} end
	wGMDB[realmName][myName] = GetMoney()
	if (wGMDB[realmName]["today_info"]==nil) then wGMDB[realmName]["today_info"] = {} end
	if (wGMDB[realmName]["today_info"]["gold"]==nil) then wGMDB[realmName]["today_info"]["gold"] = 0 end
	if (wGMDB[realmName]["today_info"]["date"]~=(dateInfo.month.."-"..dateInfo.day.."-"..dateInfo.year)) then wGMDB[realmName]["today_info"]["gold"] = 0 end
	if (wGMDB[realmName]["week_info"]==nil) then wGMDB[realmName]["week_info"] = {} end
	if (wGMDB[realmName]["week_info"]["gold"]==nil) then wGMDB[realmName]["week_info"]["gold"] = 0 end
	if (wGMDB[realmName]["week_info"]["gold"]==0) and (wGMDB[realmName]["today_info"]["gold"]~=0) then wGMDB[realmName]["week_info"]["gold"]=wGMDB[realmName]["today_info"]["gold"] end
	if (wGMDB[realmName]["week_info"]["day"]==nil) then wGMDB[realmName]["week_info"]["day"] = dateInfo.wday end
	if (wGMDB[realmName]["week_info"]["day"]>dateInfo.wday) then wGMDB[realmName]["week_info"]["gold"] = 0 end
	wGMDB[realmName]["week_info"]["day"] = dateInfo.wday
	wGMDB[realmName]["today_info"]["date"]  = (dateInfo.month.."-"..dateInfo.day.."-"..dateInfo.year)
	
end

local OnEvent = CreateFrame("Frame")
OnEvent:RegisterEvent("PLAYER_ENTERING_WORLD")
OnEvent:SetScript("OnEvent", function(self, event, arg1, arg2, arg3)
	if (event=="ADDON_LOADED") then
		moneyUpdate()
		for k,v in pairs(wGMDB[realmName]) do
			if (k~=nil) and (k~=myName) and (k~="today_info") and (k~="week_info") then
				table.insert(alts, {text = k, value = k})
			end
		end
		OnEvent:UnregisterEvent("ADDON_LOADED")
	elseif (event=="PLAYER_ENTERING_WORLD") or (event=="PLAYER_MONEY") then
		moneyUpdate()
	elseif (event=="PLAYER_LOGIN") then
		startingGold = GetMoney()
	elseif (event=="PLAYER_MONEY") then
		moneyUpdate()
	elseif (event=="PLAYER_LOGOUT") then
		wGMDB[realmName]["today_info"]["gold"] = (wGMDB[realmName]["today_info"]["gold"] + (myMoneyTotal - startingGold))
		wGMDB[realmName]["week_info"]["gold"] = (wGMDB[realmName]["week_info"]["gold"] + (myMoneyTotal - startingGold))
	end
end)
OnEvent:RegisterEvent("ADDON_LOADED")
OnEvent:RegisterEvent("PLAYER_LOGIN")
OnEvent:RegisterEvent("PLAYER_MONEY")
OnEvent:RegisterEvent("PLAYER_LOGOUT")