local cfg = CreateFrame("Frame")
local style

-----------------------------
-- STYLE DEFAULT VALUES
-----------------------------
local theme = nioDB.Theme or {}
theme = theme.Grey or false
if theme then
	style = {
		--unitframes
		unitframes = {
			bgcolor = {
				r = 0,
				g = 0,
				b = 0,
				a = 1,
			},
			bordercolor = {
				r = 0.377,
				g = 0.377,
				b = 0.377,
				a = 1,
			},
			healthBarColor = {45/255, 43/255, 43/255}, -- Healthbar's foreground color (r, g, b)
			healthBgColor = {180/255, 30/255, 15/255}, -- Healthbar's background color (r, g, b)
		},
		--background
		bg = {
			r = 0.1019607843137255,
			g = 0.09803921568627451,
			b = 0.09803921568627451,
			a = 0.8,		
		},
		--border
		border = {
			texture = "Interface\\AddOns\\nioUI\\Media\\UI-DialogBox-BorderGrey",
			size = 25,
			color = {
				r = 1,
				g = 1,
				b = 1,
				a = 1,			
			},
			insets_1 = { left = 7, right = 7, top = 7, bottom = 7},	--chat
			insets_2 = { left = 3, right = 5, top = 5, bottom = 5},	--chat
			insets_3 = { left = 5, right = 5, top = 5, bottom = 5},	--mMap
			insets_4 = { left = 8, right = 8, top = 8, bottom = 7},	--adibags
		},
		-- second color
		color2 = {
			r = 0.377,		--0/255,
			g = 0.377,		--57/255,
			b = 0.377,		--97/255,
			a = 1,		
		},
		-- ldb text color
		ldbtextcolor = {
			r = 0.8,		--0/255,
			g = 0.8,		--57/255,
			b = 0.8,		--97/255,
		},
		-- bar
		bar = "Interface\\AddOns\\nioUI\\Media\\Minimalist",
		-- font
		font = "Fonts\\FRIZQT__.TTF",
		-- action buttons
		actionbuttons = {
			NormalTexture = [[Interface\AddOns\nioUI\Media\UI-Quickslot2grey.blp]],
			Border = [[Interface\AddOns\nioUI\Media\UI-ActionButton-Border.blp]],
		},
	}

else
	style = {
		--unitframes
		unitframes = {
			bgcolor = {
				r = 0,
				g = 0,
				b = 0,
				a = 1,
			},
			bordercolor = {
				r = 0.09,
				g = 0.28,
				b = 0.43,
				a = 1,
			},
			healthBarColor = {45/255, 43/255, 43/256}, -- Healthbar's foreground color (r, g, b)
			healthBgColor = {180/255, 30/255, 15/255}, -- Healthbar's background color (r, g, b)
		},
		--background
		bg = {
			r = 0.1019607843137255,
			g = 0.09803921568627451,
			b = 0.09803921568627451,
			a = 0.8,		
		},
		--border
		border = {
			texture = "Interface\\AddOns\\nioUI\\Media\\UI-DialogBox-Border",
			size = 25,
			color = {
				r = 1,
				g = 1,
				b = 1,
				a = 1,			
			},
			insets_1 = { left = 7, right = 7, top = 7, bottom = 7},	--chat
			insets_2 = { left = 3, right = 5, top = 5, bottom = 5},	--chat
			insets_3 = { left = 5, right = 5, top = 5, bottom = 5},	--mMap
			insets_4 = { left = 8, right = 8, top = 8, bottom = 7},	--adibags
		},
		-- second color
		color2 = {
			r = 0.1411764705882353,		--0/255,
			g = 0.4313725490196079,		--57/255,
			b = 0.6549019607843137,		--97/255,
			a = 1,			
		},
		-- ldb text color
		ldbtextcolor = {
			r = 0.1411764705882353,		--0/255,
			g = 0.4313725490196079,		--57/255,
			b = 0.6549019607843137,		--97/255,		
		},
		-- bar
		bar = "Interface\\AddOns\\nioUI\\Media\\Minimalist",
		-- font
		font = "Fonts\\FRIZQT__.TTF",
		-- action buttons
		actionbuttons = {
			NormalTexture = [[Interface\AddOns\nioUI\Media\UI-Quickslot2.blp]],
			Border = [[Interface\AddOns\nioUI\Media\UI-ActionButton-Border.blp]],
		},
	}
end


-----------------------------
-- STYLE VARIANTS, NO NEED TO CHANGE
-----------------------------

--Unitframes
cfg.UnitframesBGColor = {style.unitframes.bgcolor.r, style.unitframes.bgcolor.g, style.unitframes.bgcolor.b, style.unitframes.bgcolor.a}
cfg.UnitframesBorderColor = {style.unitframes.bordercolor.r, style.unitframes.bordercolor.g, style.unitframes.bordercolor.b, style.unitframes.bordercolor.a}
cfg.UnitframesHealthBarColor = style.unitframes.healthBarColor
cfg.UnitframesHealthBgColor = style.unitframes.healthBgColor

--Background
cfg.BackgroundColors = {style.bg.r, style.bg.g, style.bg.b}
cfg.BackgroundColorsVar = style.bg.r.." "..style.bg.g.." "..style.bg.b 	--"0.1019607843137255 0.09803921568627451 0.09803921568627451"
cfg.BackgroundColorsVar2 = style.bg.r..", "..style.bg.g..", "..style.bg.b			--"0.1019607843137255, 0.09803921568627451, 0.09803921568627451"
cfg.bg = {
	r = style.bg.r,
	g = style.bg.g,
	b = style.bg.b,
	a = style.bg.a,
}
--Border
cfg.Border = style.border.texture
cfg.BorderSize = style.border.size
cfg.BorderColor = {style.border.color.r}  	--{1, 1, 1}
cfg.BorderColorVar = style.border.color.r.." "..style.border.color.g.." "..style.border.color.b		--"1 1 1"
cfg.BorderAlpha = style.border.color.a
cfg.BorderInsets_1 = style.border.insets_1  --chat
cfg.BorderInsets_2 = style.border.insets_2  --chat
cfg.BorderInsets_3 = style.border.insets_3
cfg.BorderInsets_4 = style.border.insets_4
--The blue
cfg.BlueColors = {style.color2.r, style.color2.g, style.color2.b} 		--{0.1411764705882353, 0.4313725490196079, 0.6549019607843137}
cfg.blue = {
	r = style.color2.r,
	g = style.color2.g,
	b = style.color2.b,
}
-- ldb text color
cfg.ldbtextcolor = {
	r = style.ldbtextcolor.r,
	g = style.ldbtextcolor.g,
	b = style.ldbtextcolor.b,
}
--Bar Texture
cfg.bar = style.bar
--Fonts
cfg.font = style.font
-- action buttons
cfg.actionbuttons = style.actionbuttons
-----------------------------

nioConfig = cfg
style = nil
cfg = nil