-- Configuration
-- For additional configuration look at the files for that UI-Element
-----------------------------
-- INIT
-----------------------------
local cfg = nioConfig

local Resolution = {GetScreenResolutions()}
Resolution = Resolution[GetCurrentResolution()]
cfg.Resolution = Resolution

----------------------------------------------------------------------------------------------------
-- Position and sizes (central configuration for easy adjusting on resolutions)

local Layout = {
	-- Panels
	panChat = {anchor = "BOTTOMLEFT", x_off = 0, y_off = 23,  width = 442, height = 165,},
	panAction = {anchor = "BOTTOMLEFT", x_off = 433, y_off = 23,  width = 833, height = 92,},
	panDM = {anchor = "BOTTOMRIGHT", x_off = -160, y_off = 23,  width = 262, height = 165,},
	panMinimap = {anchor = "CENTER", x_off = 0, y_off = 0,  width = "110%", height = "110%",},
	panBrokers = {anchor = "BOTTOMRIGHT", x_off = 0, y_off = 0,  width = "100%", height = 30,},
	
	-- Actionbars
	mbpos = {"BOTTOM", -13, 25},
	b2pos = {"BOTTOM", 11, 63},
	b3pos = {"BOTTOM", -303, 31},
	b4pos = {"BOTTOM", 322, 31},
	b5pos = {"LEFT", 0, 0},
	--sspos = {"BOTTOM", -280, 108},
	sspos = {"BOTTOMLEFT", 433, 108},
	petpos = {"BOTTOM", 340, 107},
	expos = {"BOTTOMLEFT", 150, 185},
	ttpos = {"BOTTOMLEFT", 443, 114},
	
	--Tooltip
	ToolTip = {anchor = "BOTTOMRIGHT", x_off = "-3", y_off = "197",},
	
	--chat, map, quest, loot
	Chat = {anchor = "BOTTOMLEFT", x_off = 10, y_off = 32,  width = 425, height = 125,},
	Minimap = {scale = 1.076, anchor = "BOTTOMRIGHT", x_off = -7, y_off = 28,},
	Quest = {scale = 1, anchor = "BOTTOMRIGHT", x_off = 0, y_off = 185, height = 550,},
	LootRoll = {scale = 1, anchor = "BOTTOMLEFT", x_off = 15, y_off = 225,},
	
	--Unitframes
	PlayerUF = {RelativePoint = "BOTTOM", x_off = -200, y_off = 425,},
	TargetUF = {RelativePoint = "BOTTOM", x_off = 200, y_off = 425,},
	RaidUF = {RelativePoint = "BOTTOM", x_off = -195, y_off = 117,},
	Raid40UF = {RelativePoint = "TOPLEFT", x_off = 10, y_off = -10,},
	
	--Castbars
	PlayerCB = {anchor = "BOTTOM", x_off = 0, y_off = 300,  width = 300, height = 30,},
	TargetCB = {anchor = "BOTTOM", x_off = 0, y_off = 338,  width = 240, height = 30,}, 
	FocusCB = {anchor = "BOTTOM", x_off = 0, y_off = 377,  width = 240, height = 30,}, 
	
	--Other bars
	Threatbar = {"BOTTOMRIGHT", -168, 188},
	AltPowerbar = {'TOP', 0, -10},
	
	--Buffs/debuffs
	Debuffbar = {x_off = -2, y_off = -3,  width = 255, height = 18,},
	DebuffsSpecial = {x_off = 425, y_off = 130,  width = 250, height = 65,},
	
	--Damage meter
	dm_pos = { "BOTTOMRIGHT", -167, 28 },
	dm_width = 247,
	dm_height = 150,
	dm_maxlines = 9,	
}
----------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------
-- 1920x1080 (only changes)
if Resolution == "1920x1080" then
	-- Panels
	Layout.panChat = {anchor = "BOTTOMLEFT", x_off = 0, y_off = 23,  width = 440, height = 165,}
	Layout.panAction = {anchor = "BOTTOMLEFT", x_off = 550, y_off = 23,  width = 840, height = 92,}
	Layout.panDM = {anchor = "BOTTOMRIGHT", x_off = -158, y_off = 23,  width = 269, height = 165,}
	--bars
	Layout.ttpos = {"BOTTOMLEFT", 558, 114}
	Layout.sspos = {"BOTTOMLEFT", 550, 110}
	Layout.Threatbar = {"BOTTOMRIGHT", -172, 188}
	--chat, map, quest, loot
	Layout.Chat = {anchor = "BOTTOMLEFT", x_off = 10, y_off = 32,  width = 423, height = 125,}
end
----------------------------------------------------------------------------------------------------


----------------------------------------------------------------------------------------------------
-- CONFIGURATION (only change, if you know, what you are doing)
----------------------------------------------------------------------------------------------------

cfg.Theme = {
	Grey = false,
}


-- TS
cfg.TS = {
	Program = "Teamspeak 3",
	Data = "YourIP:YourPort",
	PW = "Your Password",
}

-----------------------------
-- Chat
-----------------------------
cfg.Chat = {
	enable = true,
	width = Layout.Chat.width,
	height = Layout.Chat.height,
	anchor = Layout.Chat.anchor,
	x_off = Layout.Chat.x_off,
	y_off = Layout.Chat.y_off,
	font = cfg.font,
	font_size = 12,
	font_size_header = 10,
}

-----------------------------
-- Panels
-----------------------------	
lpanels:CreateLayout("nioUI", {	
	-- Background for chat on left side
	{	name = "panChat", 
		parent = UIParent,
		anchor_to = Layout.panChat.anchor,
		x_off = Layout.panChat.x_off, y_off = Layout.panChat.y_off,
		width = Layout.panChat.width, height = Layout.panChat.height,
		bg_color = cfg.BackgroundColorsVar,
		border = cfg.Border,
		border_size = cfg.BorderSize, border_alpha = cfg.BorderAlpha, border_color = cfg.BorderColorVar,
	},	
	
	-- Background for actionbars
	{	name = "panAction", 
		parent = UIParent,
		anchor_to = Layout.panAction.anchor,
		x_off = Layout.panAction.x_off, y_off = Layout.panAction.y_off,
		width = Layout.panAction.width, height = Layout.panAction.height,
		level = 0,
		bg_color = cfg.BackgroundColorsVar,
		border = cfg.Border,
		border_size = cfg.BorderSize, border_alpha = cfg.BorderAlpha, border_color = cfg.BorderColorVar,
	},	
	
	-- Background for damage meter
	{	name = "panDM", 
		parent = UIParent,
		anchor_to = Layout.panDM.anchor,
		x_off = Layout.panDM.x_off, y_off = Layout.panDM.y_off,
		width = Layout.panDM.width, height = Layout.panDM.height,
		bg_color = cfg.BackgroundColorsVar,
		border = cfg.Border,
		border_size = cfg.BorderSize, border_alpha = cfg.BorderAlpha, border_color = cfg.BorderColorVar,
	},
	
	-- Background for minimap
	{	name = "panMiniMap", 
		parent = "Minimap",
		anchor_to = Layout.panMinimap.anchor,
		x_off = Layout.panMinimap.x_off, y_off = Layout.panMinimap.y_off,
		width = Layout.panMinimap.width, height = Layout.panMinimap.height,
		bg_alpha = 0,
		border = cfg.Border,
		border_size = cfg.BorderSize, border_alpha = cfg.BorderAlpha, border_color = cfg.BorderColorVar,
	},

	-- Background for brokers
	{	name = "panBrokers", 
		parent = UIParent,
		anchor_to = Layout.panBrokers.anchor,
		x_off = Layout.panBrokers.x_off, y_off = Layout.panBrokers.y_off,
		width = Layout.panBrokers.width, height = Layout.panBrokers.height,
		bg_color = cfg.BackgroundColorsVar,
		border = cfg.Border,
		border_size = cfg.BorderSize, border_alpha = cfg.BorderAlpha, border_color = cfg.BorderColorVar,
	},
})

-----------------------------
-- Actionbars
-----------------------------
cfg.Actionbars = {
	enable = true,
	-- Config
	autoenable = true,
	globalscale = 1,
	barspacing = 2,
	hide_hotkey = true,
	hide_macro_name = true,
	show_totembar =	true,
	show_extraactionbutton = true,

	--Main Bar
	mbrows = 1,      -- 1, 2, 3, 4, 6, 12 are valid
	mbalpha = 1,     -- Button Alpha
	mbbsize = 30,
	mbmo = false,    -- Hide unless mouseover
	mbpos = Layout.mbpos,

	--Bar 2
	b2rows = 1,      -- 1, 2, 3, 4, 6, 12 are valid
	b2alpha = 1,     -- Button Alpha
	b2bsize = 30,
	b2mo = false,    -- Hide unless mouseover
	b2pos = Layout.b2pos,

	--Bar 3
	b3rows = 2,      -- 1, 2, 3, 4, 6, 12 are valid
	b3alpha = 1,     -- Button Alpha
	b3bsize = 25,
	b3mo = false,    -- Hide unless mouseover
	b3pos = Layout.b3pos,

	--Right Bar 1
	b4rows = 2,    -- 1, 2, 3, 4, 6, 12 are valid
	b4alpha = 1,     -- Button Alpha
	b4bsize = 25,
	b4mo = false,     -- Hide unless mouseover
	b4pos = Layout.b4pos,

	--Right Bar 2
	b5rows = 12,     -- 1, 2, 3, 4, 6, 12 are valid
	b5alpha = 1,     -- Button Alpha
	b5bsize = 30,
	b5mo = true,    -- Hide unless mouseover
	b5pos = Layout.b5pos,

	--Shapeshift Bar
	ssrows = 1,      -- 1 or 12 are valid for horizontal/vertical
	ssalpha = 1,     -- Button Alpha
	ssbsize = 26,
	ssmo = true,     -- Hide unless mouseover
	sspos = Layout.sspos,

	--Pet Bar
	petrows = 2,     -- 1 or 12 are valid for horizontal/vertical
	petalpha = 1,    -- Button Alpha
	petbsize = 26,
	petmo = false,   -- Hide unless mouseover
	petpos = Layout.petpos,

	--Extra Action Button
	expos = Layout.expos,

	--Totem Bar
	ttpos = Layout.ttpos,
}

-----------------------------
-- Minimap
-----------------------------
cfg.Map = {
	enable = true,
	map_scale = Layout.Minimap.scale,     					-- Scale of the minimap
	map_position = Layout.Minimap.anchor,        	-- Initial position. Values = "TOPRIGHT", "TOPLEFT", "BOTTOMRIGHT", "BOTTOMLEFT", "TOP", "BOTTOM", "RIGHT", "LEFT"
	map_offsetX = Layout.Minimap.x_off,						-- X Offset from map_position
	map_offsetY = Layout.Minimap.y_off,						-- Y Offset from map_position

	map_hideInstanceDifficulty = false,		-- Hides / shows the instance difficulty icon on the minimap. Values = true/false
	map_showCoordinates = false,		-- Shows the X,Y coordinates of your current location. Values = true/false
}

-----------------------------
-- Worldmap
-----------------------------
cfg.WorldMap = {
	enable = true,
	map_scale = 0.9,						-- Mini World Map scale
	map_position = {"CENTER",UIParent,"CENTER",0,65},	--set position for locked map
	lock_map_position = true,		-- lock your map in set position
	group_icon_size = 20,			-- group icons size
}

-----------------------------
-- Questwatchframe
-----------------------------
cfg.Quest = {
	enable = true,
	height = Layout.Quest.height,
	scale = Layout.Quest.scale,
	anchor = Layout.Quest.anchor,
	x_off = Layout.Quest.x_off,
	y_off = Layout.Quest.y_off,
	font_size = 12,
	questSpacing = 10,
	lineSpacing = 4,
	instance = false,
	hideFrame = true,
}

-----------------------------
-- Loot roll frame
-----------------------------
cfg.LootRoll = {
	scale = Layout.LootRoll.scale,
	anchor = Layout.LootRoll.anchor,
	x_off = Layout.LootRoll.x_off,
	y_off = Layout.LootRoll.y_off,
	grow = "TOP",
}

-----------------------------
-- Tooltip
-----------------------------
cfg.TipTopDB = {
	["raidIconX"] = "0",
	["healthText"] = true,
	["raidIconSize"] = 16,
	["factionIconY"] = "-4",
	["anchor"] = Layout.ToolTip.anchor,
	["offsetX"] = Layout.ToolTip.x_off,
	["offsetY"] = Layout.ToolTip.y_off,
	["borderColor"] = cfg.blue,
	["bg"] = "Solid",
	["sbarbgcolor"] = {
		["a"] = 0.4,
		["b"] = 0,
		["g"] = 0,
		["r"] = 0,
	},
	["healthBar"] = cfg.bar,
	["onCursor"] = false,
	["raidIconY"] = "0",
	["font"] = cfg.font,
	["textformat"] = "100%",
	["classIcon"] = false,
	["insideBar"] = true,
	["factionIconSize"] = 32,
	["scale"] = 1,
	["border"] = "nioUI_WhiteBorder",
	["bgColor"] = cfg.bg,
	["factionIconPosition"] = "TOPRIGHT",
	["inset"] = 5,
	["factionIcon"] = false,
	["showTalentText"] = true,
	["diffColor"] = true,
	["showTargetText"] = true,
	["sbarcolor"] = {
		["a"] = 1,
		["b"] = 0,
		["g"] = 1,
		["r"] = 0,
	},
	["borderWidth"] = 23,
	["fontFlag"] = "None",
	["alpha"] = 1,
	["sbarclass"] = true,
	["classColor"] = true,
	["raidIconPosition"] = "TOP",
	["topBar"] = false,
	["itemColor"] = true,
	["factionIconX"] = "-16",
	["elite"] = true,
	["you"] = true,
	["sbarbg"] = cfg.bar,
}	

-----------------------------
-- Misc
-----------------------------
cfg.Misc = {
	tekkompare = true,
	CharacterEquip = true,
	SetRoleAutomatic = true,
	autorepair = true,
	guildfunds = false,
	sellgray = true,
	DamageMeter = true,
	petbattlehide = true,
}

-----------------------------
-- Numeration
-----------------------------
cfg.DamageMeter = {
	pos = Layout.dm_pos,
	width = Layout.dm_width,
	height = Layout.dm_height,
	maxlines = Layout.dm_maxlines,	
}

-----------------------------
-- Buffs
-----------------------------
cfg.Buffs = {
	["whoCast"] = true,
	["sbar"] = "nioUI_Bar",
	["fstyle"] = "Outline",
	["allWhiteText"] = true,
	["border"] = "nioUI_WhiteBorder",
	["bprow"] = 10,
	["bgColor"] = {
		["r"] = 0.2509803921568627,
		["g"] = 0.2509803921568627,
		["b"] = 0.2509803921568627,
	},
	["posX"] = -5,
	["bg"] = "Solid",
	["posY"] = -10,
	["borColor"] = cfg.blue,
	["classbar"] = false,
	["font"] = cfg.font,
	["classbor"] = false,
	["classbg"] = false,
	["sbarColor"] = {
		["r"] = 0.9294117647058824,
		["g"] = 0.9215686274509803,
		["b"] = 0.9529411764705882,
	},
	["buffs"] = {
		["dfsize"] = 10,
		["cfsize"] = 14,
		["size"] = 36,
	},
	["borAlpha"] = 0.4,
	["debuffs"] = {
		["dfsize"] = 12,
		["cfsize"] = 14,
		["size"] = 40,
	},
}

-----------------------------
-- Unitframes
-----------------------------
local defaultSpacing = 6
local mediaFolder = "Interface\\AddOns\\nioUI\\Unitframes\\oUF_niodrk\\media\\"

cfg.Unitframes = {
	-- Show/hide frames:
	showTot = true, -- show target of target frame
	showPet = true, -- show pet frame
	showPetTarget = true, -- show pet frame
	showFocus = true, -- show focus frame
	showFocusTarget = true, -- show focus target frame
	showBossFrames = true,	-- Show boss frames
	showArenaFrames = true,	-- Show arena frames

	showParty = true, -- show party frames (shown as 5man raid)
	showRaid = true, -- show raid frames
	raidShowSolo = false, -- show raid frames even when solo
	raidShowAllGroups = false, -- show raid groups 6, 7 and 8 (more than 25man raid)
	
	-- Misc frame settings
	raidScale = 1, -- scale factor for raid frames
	frameScale = 1, -- scale factor for all other frames
	classBar = true,	-- show player class bar
	showPortraits = true,	--shows portraits on player and target frames
	healthBarColor = nioConfig.UnitframesHealthBarColor, -- Healthbar's foreground color (r, g, b)
	healthBgColor = nioConfig.UnitframesHealthBgColor, -- Healthbar's background color (r, g, b)
	
	-- Show/hide Blizzard Stuff
	hideBuffFrame = false, -- hide Blizzard's default buff frame (best to keep it on until you can cancel buffs in oUF again)
	hideWeaponEnchants = false, -- hide Blizzard's default temporary weapon enchants frame (best to keep it on until you can cancel buffs in oUF again)
	hideRaidFrame = true, -- hide Blizzard's default raid frames
	hideRaidFrameContainer = true, -- hide Blizzard's default raid container (that frame with the role check button, colored ground marks, etc)
	
	-- Plugins
	ShowIncHeals = true,	-- Show incoming heals in player and raid frames
	smoothHealth = true, -- Smooth healthbar updates
	smoothPower = true, -- Smooth powerbar updates
	enableDebuffHighlight = true, -- Edable Highlighting of dispellable debuffs
	showPlayerClassIndicators = true, -- Shows Indicators on raid frames, based on the player class
	showDefCDsIndicators = true, -- Shows Indicators for defensive cooldowns on raid frames
	useRaidDebuffBlacklist = true, -- Uses a Blacklist to show debuffs on raid frames. If set to false, uses the whitelist instead
	ThreatBar = true,  -- Show ThreatBar
	Reputation = false,
	AltPowerBar = true,
	Experience = false,
	
	-- Frame positioning
	playerX = Layout.PlayerUF.x_off, -- Player frame's x-offset position from the relative point of the screen
	playerY = Layout.PlayerUF.y_off, -- Player frame's y-offset position from the relative point of the screen
	playerRelativePoint = Layout.PlayerUF.RelativePoint, -- Player frame's reference point of the screen used for X and Y offsets. Possible values are: "TOP"/"BOTTOM"/"LEFT"/"RIGHT"/"CENTER"/"TOPLEFT"/"ROPRIGHT"/"BOTTOMLEFT"/"BOTTOMRIGHT"
	targetX = Layout.TargetUF.x_off, -- Target frame's x-offset position from the relative point of the screen
	targetY = Layout.TargetUF.y_off, -- Target frame's y-offset position from the relative point of the screen
	targetRelativePoint = Layout.TargetUF.RelativePoint, -- Target frame's reference point of the screen used for X and Y offsets. Possible values are: "TOP"/"BOTTOM"/"LEFT"/"RIGHT"/"CENTER"/"TOPLEFT"/"ROPRIGHT"/"BOTTOMLEFT"/"BOTTOMRIGHT"
	
	raidX = Layout.RaidUF.x_off, -- Raid/Party x-offset position from the relative point of the screen
	raidY = Layout.RaidUF.y_off, -- Raid/Party y-offset position from the relative point of the screen
	raidRelativePoint = Layout.RaidUF.RelativePoint, -- Raid/Party's reference point of the screen used for X and Y offsets. Possible values are: "TOP"/"BOTTOM"/"LEFT"/"RIGHT"/"CENTER"/"TOPLEFT"/"ROPRIGHT"/"BOTTOMLEFT"/"BOTTOMRIGHT"	
	raidAnchorPoint = "BOTTOM", -- Defines the raid's anchor point. "BOTTOM" will make the raid groups grow upwards, "TOP" will grow downwards.
	raidPoint = "LEFT",	
	raidgrowthDirection = "RIGHT", -- Valid values: "RIGHT" or "LEFT" when HorizontalGroupGrowth is true and "RIGHT", "LEFT", "UP", "DOWN" when HorizontalGroupGrowth is false.
	raidspacing = 7,
	raidsplitGroups = false, -- use this to slip raid into groups
	raidHorizontalGroupGrowth = true, -- If false groups are columns, if true group are rows
	
	raid40X = Layout.Raid40UF.x_off, -- 40man Raid/Party x-offset position from the relative point of the screen
	raid40Y = Layout.Raid40UF.y_off, -- 40man Raid/Party y-offset position from the relative point of the screen
	raid40RelativePoint = Layout.Raid40UF.RelativePoint, -- 40man Raid/Party's reference point of the screen used for X and Y offsets. Possible values are: "TOP"/"BOTTOM"/"LEFT"/"RIGHT"/"CENTER"/"TOPLEFT"/"ROPRIGHT"/"BOTTOMLEFT"/"BOTTOMRIGHT"
	raid40AnchorPoint = "TOP", -- Defines 40man raid's anchor point. "BOTTOM" will make the raid groups grow upwards, "TOP" will grow downwards.
	
	Threatbar = Layout.Threatbar,
	AltPowerbar = Layout.AltPowerbar,

	-- Castbars
	Castbars = {
		player = {
			enable = true,
			inline = false,
			anchorPoint = Layout.PlayerCB.anchor,
			offsetX = Layout.PlayerCB.x_off,
			offsetY = Layout.PlayerCB.y_off,
			height = Layout.PlayerCB.height,
			width = Layout.PlayerCB.width,
		},
		target = {
			enable = true,
			inline = false,
			anchorPoint = Layout.TargetCB.anchor,
			offsetX = Layout.TargetCB.x_off,
			offsetY = Layout.TargetCB.y_off,
			height = Layout.TargetCB.height,
			width = Layout.TargetCB.width,
		},
		focus = {
			enable = true,
			inline = false,
			anchorPoint = Layout.FocusCB.anchor,
			offsetX = Layout.FocusCB.x_off,
			offsetY = Layout.FocusCB.y_off,
			height = Layout.FocusCB.height,
			width = Layout.FocusCB.width,	
		},
		boss = {
			enable = true,
			inline = true,	
		},
		arena = {
			enable = true,
			inline = true,	
		},
		default = {
			enable = true,
			inline = true,	
		},
	},	

	-- Auras
	showPlayerBuffs = true,
	showSpecialDebuffs = true,
	showPlayerDebuffs = false,
	showPlayerAuraBars = true,
	showPlayerDebuffBars = true,
	PlayerDebuffsFrameBlacklist = true,

	showTargetBuffs = true,
	showTargetDebuffs = true,
	showToTDebuffs = true,
	showPetBuffs = false,
	showPetDebuffs = false,
	showFocusBuffs = false,
	showFocusDebuffs = true,
	showBossBuffs = true,	

	-- Aura positioning
	auras = {
		spacing = defaultSpacing,
		BUFFPOSITIONS = {
			player = {
				anchorPoint = 'TOPRIGHT',
				relativeFrame = nil,
				relativePoint = 'TOPLEFT',
				offsetX = -defaultSpacing-2,
				offsetY = 0,
				height = 50,
				width = 250,
				number = 20,
				size = 20,
				growthX = 'LEFT',
				growthY = 'DOWN',
				filter = false,
			},
			target = {
				anchorPoint = 'TOPLEFT',
				relativeFrame = nil, -- default to self
				relativePoint = 'TOPRIGHT',
				offsetX = defaultSpacing+2,
				offsetY = 0,
				height = 50,
				width = 250,
				number = 20,
				size = 20,
				growthX = 'RIGHT',
				growthY = 'DOWN',
				filter = false,
			},
			pet = {
				anchorPoint = 'TOPRIGHT',
				relativeFrame = nil,
				relativePoint = 'TOPLEFT',
				offsetX = -defaultSpacing,
				offsetY = 0,
				height = 20,
				width = 250,
				number = 10,
				size = 20,
				growthX = 'LEFT',
				growthY = 'DOWN',
				filter = false,
			},
			focus = {
				anchorPoint = 'TOPLEFT',
				relativeFrame = nil, -- default to self
				relativePoint = 'TOPRIGHT',
				offsetX = defaultSpacing,
				offsetY = 0,
				height = 25,
				width = 250,
				number = 10,
				size = 20,
				growthX = 'RIGHT',
				growthY = 'DOWN',
				filter = false,
			},
			boss = {
				anchorPoint = 'TOPLEFT',
				relativeFrame = nil, -- default to self
				relativePoint = 'TOPRIGHT',
				offsetX = defaultSpacing,
				offsetY = 0,
				height = 25,
				width = 250,
				number = 10,
				size = 20,
				growthX = 'RIGHT',
				growthY = 'DOWN',
				filter = false,
			},
			arena = {
				anchorPoint = 'TOPLEFT',
				relativeFrame = nil, -- default to self
				relativePoint = 'TOPRIGHT',
				offsetX = defaultSpacing,
				offsetY = 0,
				height = 25,
				width = 250,
				number = 10,
				size = 20,
				growthX = 'RIGHT',
				growthY = 'DOWN',
				filter = false,
			},
		},

		DEBUFFPOSITIONS = {
			player = {
				anchorPoint = 'TOPLEFT',
				relativeFrame = nil,
				relativePoint = 'BOTTOMLEFT',
				offsetX = 0,
				offsetY = -defaultSpacing,
				height = 54,
				width = 250,
				number = 18,
				size = 28,
				growthX = 'RIGHT',
				growthY = 'DOWN',
				playerOnly = false,
				filter = false,
			},
			debuffbars = {
				anchorPoint = 'TOPLEFT',
				relativeFrame = nil,
				relativePoint = 'BOTTOMLEFT',
				offsetX = Layout.Debuffbar.x_off,
				offsetY = Layout.Debuffbar.y_off,
				height = Layout.Debuffbar.height,
				width = Layout.Debuffbar.width,
				spacing = 1,
				grow_down = true,		
			},
			target = {
				anchorPoint = 'TOPLEFT',
				relativeFrame = nil, -- default to self
				relativePoint = 'BOTTOMLEFT',
				offsetX = 0,
				offsetY = -defaultSpacing,
				height = 54,
				width = 250,
				number = 18,
				size = 20,
				growthX = 'RIGHT',
				growthY = 'DOWN',
				playerOnly = false,
				filter = false,
			},
			targettarget = {
				anchorPoint = 'TOPLEFT',
				relativeFrame = nil, -- default to self
				relativePoint = 'TOPRIGHT',
				offsetX = defaultSpacing+2,
				offsetY = 0,
				height = 16,
				width = 250,
				number = 6,
				size = 14,
				growthX = 'RIGHT',
				growthY = 'UP',
				filter = false,
			},
			focus = {
				anchorPoint = 'BOTTOMLEFT',
				relativeFrame = nil, -- default to self
				relativePoint = 'TOPLEFT',
				offsetX = 0,
				offsetY = defaultSpacing,
				height = 16,
				width = 250,
				number = 15,
				size = 14,
				growthX = 'RIGHT',
				growthY = 'UP',
				playerOnly = false,
				filter = false,
			},
			pet = {
				anchorPoint = 'BOTTOMLEFT',
				relativeFrame = nil, -- default to self
				relativePoint = 'TOPLEFT',
				offsetX = 0,
				offsetY = defaultSpacing,
				height = 16,
				width = 250,
				number = 15,
				size = 14,
				growthX = 'RIGHT',
				growthY = 'UP',
				playerOnly = false,
				filter = false,
			},
			raid = {
				anchorPoint = 'BOTTOMLEFT',
				relativeFrame = nil, -- default to self
				relativePoint = 'CENTER',
				offsetX = -10,
				offsetY = -10,
				height = 16,
				width = 250,
				number = 2,
				size = 14,
				growthX = 'RIGHT',
				growthY = 'UP',
				playerOnly = false,
				filter = false,
			},
		},
		
		SPECIALDEBUFFPOSITIONS = {
			player = {
				anchorPoint = 'TOPLEFT',
				relativeFrame = nil,
				relativePoint = 'BOTTOMLEFT',
				offsetX = Layout.DebuffsSpecial.x_off,
				offsetY = Layout.DebuffsSpecial.y_off,
				height = Layout.DebuffsSpecial.height,
				width = Layout.DebuffsSpecial.width,
				number = 2,
				size = 50,
				growthX = 'RIGHT',
				growthY = 'DOWN',
				playerOnly = false,
				filter = false,
			},
			target = {
				anchorPoint = 'TOPRIGHT',
				relativeFrame = nil, -- default to self
				relativePoint = 'TOPLEFT',
				offsetX = -defaultSpacing,
				offsetY = 0,
				height = 54,
				width = 250,
				number = 2,
				size = 50,
				growthX = 'LEFT',
				growthY = 'DOWN',
				playerOnly = false,
				filter = false,
			},
			focus = {
				anchorPoint = 'TOPRIGHT',
				relativeFrame = nil, -- default to self
				relativePoint = 'TOPLEFT',
				offsetX = -defaultSpacing,
				offsetY = 0,
				height = 16,
				width = 250,
				number = 15,
				size = 20,
				growthX = 'LEFT',
				growthY = 'DOWN',
				playerOnly = false,
				filter = false,
			},
		},
	},	

	--Textures
	statusBarTexture = mediaFolder.."Statusbar",
	powerBarTexture = mediaFolder.."Aluminium",
	backdropTexture = mediaFolder.."backdrop",
	highlightTexture = mediaFolder.."raidbg",
	debuffHighlightTexture = mediaFolder.."perl2",
	portraitBGTexture = mediaFolder.."portrait",
	portraitOverlayTexture = mediaFolder.."portraitOverlay",
	backdropEdgeTexture = mediaFolder.."backdrop_edge",
	debuffBorderTexture = mediaFolder.."iconborder",
	glowTexture = mediaFolder.."glow",

	--Fonts
	font = mediaFolder.."font_main.ttf",
	smallfont = mediaFolder.."font_small.ttf",
	nanofont = mediaFolder.."font_nano.ttf"	,
}


-- -----------------------------
-- -- Nameplates
-- -----------------------------
cfg.Nameplates = {
	enable = true,
	OnlyForTanks = false,
}	

-----------------------------
-- tullaCC
-----------------------------
cfg.tullaCC = {
	enable = true,
	--font settings
	fontFace = cfg.font,  --what font to use
	fontSize = 18,  --the base font size to use at a scale of 1

	--display settings
	minScale = 0.6, --the minimum scale we want to show cooldown counts at, anything below this will be hidden
	minDuration = 3, --the minimum number of seconds a cooldown's duration must be to display text
	expiringDuration = 5,  --the minimum number of seconds a cooldown must be to display in the expiring format

	--text format strings
	expiringFormat = '|cffff0000%d|r', --format for timers that are soon to expire
	secondsFormat = '|cffffff00%d|r', --format for timers that have seconds remaining
	minutesFormat = '|cffffffff%dm|r', --format for timers that have minutes remaining
	hoursFormat = '|cff66ffff%dh|r', --format for timers that have hours remaining
	daysFormat = '|cff6666ff%dh|r', --format for timers that have days remaining
}

-----------------------------
-- LDBs
-----------------------------
cfg.LDB = {
	CargoShip = true,
	MicroMenu = true,
	XP = true,
	Addons = true,
	Raid = true,
	Clock = true,
	ClockLocal = true,	
	Dura = true,	
	Money = true,	
	FPS = true,	
	Latency = true,	
	Memory = true,
	Equipment = true,	
	Guild = true,
	Friends = true,
	Professions = true,
	SpecSwitcher = true,
}

----------------------------------------------------------------------------------------------------

-- If nioOptions is used, get the option
if IsAddOnLoaded("nioUIOptions") then
	--global
	for d,s in pairs(nioDB) do
		for k,v in pairs(s) do
			cfg[d][k] = v
		end				
	end
	--char specific
	for d,s in pairs(nioDBC) do
		for k,v in pairs(s) do
			cfg[d][k] = v
		end				
	end
end

nioConfig = cfg
Layout = nil
cfg = nil